package com.example.a8_bitinvader;

import java.util.LinkedList;
import java.util.Queue;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.util.Log;


public class Player extends Sprite{

    /** Health of player */
    private int health = 3;

    /** Speed */
    public final int SPEED_MULTIPLIER = 10;

    /**
     * Constructs a new player at given coordinates and
     * @param xPos Xposition of player
     * @param yPos Y position of player
     * @param xVel X velocity of player
     * @param yVel Y velocity of player
     * @param res Resource object
     */
    public Player(int xPos, int yPos, int xVel, int yVel, Resources res) {
        super(xPos,yPos,xVel,yVel);
        this.xPos = xPos;
        this.yPos = yPos;
        spriteImage = BitmapFactory.decodeResource(res, R.drawable.player);
        spriteImage = Bitmap.createScaledBitmap(spriteImage, getSpriteWidth(), getSpriteHeight(), false);
    }

    //get input from the joystick, and change the location

    // tbh I think this is going to give us an error ltr, because we are going to call update and shoot constantly, I wonder what will happen if we write and deleting at the same time. We'll see tho

    /**
     * Update the position of the player based on joystick offset
     * @param joyStickInputX X input from joystick
     * @param joyStickInputY Y input from joystick
     */
    public void update(int joyStickInputX, int joyStickInputY){
        xPos += joyStickInputX;
        yPos += joyStickInputY;
    }

    /**
     * Checks if the given points are within the sprite and reduce the health if so
     * @param xx Other X point
     * @param yy Other Y point
     * @return True if input xx and yy are within the sprite
     */
    @Override //the return doesn't really mean anything all we need is that when any of the point hit within the hit box of player, call the loose health function.
    public boolean checkForCollision(int xx, int yy)
    {
        if( super.checkForCollision(xx,yy) ) {
            loseHealth();
            return true;
        } else {
            return false;
        }
    }

    /**
     * Decrease the health of the player
     */
    // when loseHealth drop the help to 0, call the destroy function. which we will override ltr
    private void loseHealth() {
        health -= 1;
        if (health == 0) {
            destroy();
        }
    }


    public void shoot() {

    }

    @Override
    public void destroy() {
        //call animation also.
        //this should call the pulse function for the game, and manu would pop up.
        //implement ltr
    }

}
